﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Threading;

namespace Hitsuji.Clock.ToyoOn
{
    /// <summary>
    /// ToyoOnClock.xaml の相互作用ロジック
    /// </summary>
    public partial class ToyoOnClock : UserControl
    {
        public ToyoOnClock()
        {
            InitializeComponent();
        }

        private void UserControl_Loaded(object sender, RoutedEventArgs e)
        {
            initImageSource();
            Thread thread = new System.Threading.Thread(new System.Threading.ThreadStart(runTime));
            thread.IsBackground = true;
            thread.Name = "Thread-Clock";
            thread.Start();

        }


        protected void initImageSource()
        {
            String imageFile = new StringBuilder("./Images/" + new Random().Next(1, 8).ToString("00") + ".JPG").ToString();
            DataContext = imageFile;
        }

        protected void runTime()
        {
            bool separatorDisplay = true;
            while (true)
            {
                var nowTime = DateTime.Now;

                //更新処理内容
                Action act = delegate()
                {
                    this.label1.Content = new StringBuilder(" ")
                                                    .Append(nowTime.Month.ToString("00"))
                                                    .Append("/")
                                                    .Append(nowTime.Day.ToString("00"))
                                                    .Append("  ")
                                                    .Append(nowTime.Hour.ToString("00"))
                                                    .Append(" : ")
                                                    .Append(nowTime.Minute.ToString("00"))
                                                    .Append(getSeparator(ref separatorDisplay)).ToString();
                };

                //更新処理実行
                this.Dispatcher.Invoke(act);
                Thread.Sleep(500);
            }
        }

        protected String getSeparator(ref bool separatorDisplay)
        {
            if (separatorDisplay)
            {
                separatorDisplay = false;
                return " ♪";
            }
            else
            {
                separatorDisplay = true;
                return "  ♪";
            }
        }
    }
}
