﻿using System;
using System.ComponentModel;
using Hitsuji.Framework.Commands;

namespace Hitsuji.Framework.Models
{
    public class CommandBindableModel : INotifyPropertyChanged
    {
        public PropertyChangedCommand Command
        {
            get;
            set;
        }

        public CanExecuteDelegate canExeDelegate_;
        public executeDelegate exeDelegate_;


        public event PropertyChangedEventHandler PropertyChanged;
        protected void OnPropertyChanged(String propertyName)
        {
            try
            {
                PropertyChangedEventHandler handle = PropertyChanged;
                if (handle != null)
                    handle(this, new PropertyChangedEventArgs(propertyName));
            }
            catch (Exception ex)
            {
                Console.Write(ex.ToString());
            }
        }

    }
}
