﻿using System.Collections.Generic;

namespace Hitsuji.Framework.ViewModels
{
    public class ViewModelFactory// : IViewModelFactory
    {

        #region IViewModelFactory メンバ
        public static AViewModel createViewModel(System.Windows.FrameworkElement viewElement,
                                                 AViewModel viewModel,
                                                 Dictionary<string, AViewModel> viewModels)
        {
            viewModel.setVVMRefarence(viewElement);
            viewModel.ViewModelDictionary = viewModels;
            if (viewModels != null)
            {
                if (!string.IsNullOrEmpty(viewModel.ViewModelName))
                {
                    viewModels.Add(viewModel.ViewModelName, viewModel);
                }
                else
                {
                    viewModels.Add(viewModel.GetType().Name, viewModel);
                }
            }


            return viewModel;
        }

        #endregion
    }
}
