﻿using System;
using System.Windows;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Hitsuji.Framework.ViewModels
{
    public class ViewModelManager
    {
        //制御
        private ViewModelManager() { }


        private static Dictionary<string, AViewModel> ViewModelDictionary;
        public static Dictionary<string, AViewModel> getInstance()
        {
            if (ViewModelDictionary == null)
            {
                ViewModelDictionary = new Dictionary<string, AViewModel>();
            }
            return ViewModelDictionary;
        }


        public static void addViewModel(FrameworkElement view,  AViewModel viewModel)
        {
            if (ViewModelDictionary == null)
                ViewModelDictionary = new Dictionary<string, AViewModel>();

            //ViewとViewModelの関連付け
            if(view != null)
                viewModel.setVVMRefarence(view); 

            //コレクションへ登録
            ViewModelDictionary.Add(viewModel.GetType().Name, viewModel);
        }


        public static bool tryGetViewModel(string viewModelName)
        {
            AViewModel vm = null;
            return ViewModelDictionary.TryGetValue(viewModelName, out vm);
        }
    }
}
