﻿using Hitsuji.Framework.Directories;

namespace Hitsuji.Nengajou.Models.DataBases
{
    public class FilePathDataBase
    {
        //
        public static readonly string NengajouHitsujiRootDirectory = "\\NengajouHitsuji";
        public static readonly string NengajouHitsujiInfoDirectory = "\\INFO";
        public static readonly string NengajouHitsujiLayoutDictionary = "\\LAYOUT_INFO";
        public static readonly string NengajouHitsujiReseiverDirectory = "RESEIVER";
        public static readonly string NengajouHitsujiIllustDictionary = "\\ILLUST";
        public static readonly string NengajouHitsujiPrintoutInfoDictionary = "\\PRINTOUT_INFO";

        public static readonly string MyPersonalInfoFile = "\\MY_PERSONAL_INFO.xml";
        public static readonly string OtherPersonalInfoFile = "\\OTHER_PERSONAL_INFO.xml";
        public static readonly string GroupInfoFile = "\\GROUP_INFO.xml";
        public static readonly string PostInfoFile = "\\POST_INFO.xml";
        public static readonly string YearInfoFile = "\\YEAR_INFO.xml";
        public static readonly string NPFInfoFile = "\\NPF_INFO.xml";
        public static readonly string FontFamilyFile = "\\FONT_FAMILY_INFO.xml";
        public static readonly string IllustFile = "\\DEFAULT_IMAGE.jpg";
        public static readonly string ReseiverLayoutFile = "\\RESEIVER_LAYOUT.xml";
        public static readonly string IllustLayoutFile = "\\Illust_LAYOUT.xml";
        public static readonly string PrintoutReseiverLayoutFile = "\\PRINT_RESEIVER_LAYOUT.xml";
        public static readonly string PrintoutIllustLayoutFile = "\\PRINT_ILLUST_LAYOUT.xml";


        public static string getInfoDirectory()
        {
            return HitsujiDirectory.getHitsujisCommonDirectory()
                        + NengajouHitsujiRootDirectory
                        + NengajouHitsujiInfoDirectory;
        }
        public static string getLayoutInfoDirectory()
        {
            return HitsujiDirectory.getHitsujisCommonDirectory()
                        + NengajouHitsujiRootDirectory
                        + NengajouHitsujiLayoutDictionary;
        }
        public static string getPrintLayoutDirectory()
        {
            return HitsujiDirectory.getHitsujisCommonDirectory()
                        + NengajouHitsujiRootDirectory
                        + NengajouHitsujiPrintoutInfoDictionary;
        }
        public static string getIllustDirectoryPath()
        {
            return HitsujiDirectory.getHitsujisCommonDirectory()
                        + NengajouHitsujiRootDirectory
                        + NengajouHitsujiIllustDictionary;
        }
        
        //MyPersonalInfo
        public static string getMyPersonalFilePath()
        {
            return HitsujiDirectory.getHitsujisCommonDirectory()
                        + NengajouHitsujiRootDirectory
                        + NengajouHitsujiInfoDirectory
                        + MyPersonalInfoFile;
        }

        //OtherPersonalInfo
        public static string getOtherPersonalFilePath()
        {
            return HitsujiDirectory.getHitsujisCommonDirectory()
                        + NengajouHitsujiRootDirectory
                        + NengajouHitsujiInfoDirectory
                        + OtherPersonalInfoFile;
        }

        //GroupInfo
        public static string getGroupFilePath()
        {
            return HitsujiDirectory.getHitsujisCommonDirectory()
                        + NengajouHitsujiRootDirectory
                        + NengajouHitsujiInfoDirectory
                        + GroupInfoFile;
        }

        //PostInfo
        public static string getPostFilePath()
        {
            return HitsujiDirectory.getHitsujisCommonDirectory()
                        + NengajouHitsujiRootDirectory
                        + NengajouHitsujiInfoDirectory
                        + PostInfoFile;
        }

        //YearInfo
        public static string getYearFilePath()
        {
            return HitsujiDirectory.getHitsujisCommonDirectory()
                        + NengajouHitsujiRootDirectory
                        + NengajouHitsujiInfoDirectory
                        + YearInfoFile;
        }

        //NamePostInfo
        public static string getNamePostFilePath()
        {
            return HitsujiDirectory.getHitsujisCommonDirectory()
                        + NengajouHitsujiRootDirectory
                        + NengajouHitsujiInfoDirectory
                        + NPFInfoFile;
        }
        
        //FontFamilyInfo
        public static string getFontFamilyFilePath()
        {
            return HitsujiDirectory.getHitsujisCommonDirectory()
                        + NengajouHitsujiRootDirectory
                        + NengajouHitsujiInfoDirectory
                        + FontFamilyFile;
        }

        //IllustInfo
        public static string getIllustFileFilePath()
        {
            return HitsujiDirectory.getHitsujisCommonDirectory()
                        + NengajouHitsujiRootDirectory
                        + NengajouHitsujiIllustDictionary
                        + IllustFile;
        }


        //ReseiverLayoutInfo
        public static string getReseiverLayoutFilePath()
        {
            return HitsujiDirectory.getHitsujisCommonDirectory()
                        + NengajouHitsujiRootDirectory
                        + NengajouHitsujiLayoutDictionary
                        //+ NengajouHitsujiReseiverDirectory
                        + ReseiverLayoutFile;
        }
        
        //IllustLayoutInfo
        public static string getIllustLayoutFilePath()
        {
            return HitsujiDirectory.getHitsujisCommonDirectory()
                        + NengajouHitsujiRootDirectory
                        + NengajouHitsujiLayoutDictionary
                        + IllustLayoutFile;
        }

        //Printout ReseiverLayout
        public static string getPrintoutReseiverLayoutFilePath()
        {
            return HitsujiDirectory.getHitsujisCommonDirectory()
                        + NengajouHitsujiRootDirectory
                        + NengajouHitsujiPrintoutInfoDictionary 
                        + PrintoutReseiverLayoutFile;
        }

        //Printout IllustLayout
        public static string getPrintoutIllustLayoutFilePath()
        {
            return HitsujiDirectory.getHitsujisCommonDirectory()
                        + NengajouHitsujiRootDirectory
                        + NengajouHitsujiPrintoutInfoDictionary
                        + PrintoutIllustLayoutFile;
        }

        //テスト用
        public static string getDeskTop()
        {
            var str = System.Environment.GetFolderPath(System.Environment.SpecialFolder.DesktopDirectory) + "\\TEST.xml";
            return str;
        }


    }
}
