﻿using System;
using System.Text;
using System.Xml;
using System.Xml.Linq;
using Hitsuji.Framework.ObserverPattern.Observers;
using Hitsuji.Framework.ObserverPattern.Subjects;
using Hitsuji.Nengajou.Models.DataBases;
using Hitsuji.Nengajou.ObserverPattern.Subjects;

namespace Hitsuji.Nengajou.ObserverPattern.Observers
{
    public class CreateIllustLayoutForPrintObserver : IObserver
    {
        #region IObserver メンバ

        public string outputPath;

        public void doMyRole(ASubject aSubject)
        {
            try
            {
                GetIllustLayoutInfoSubject subject = aSubject as GetIllustLayoutInfoSubject;
                
                var doc = new XDocument();
                var rootElem = new XElement(IllustLayoutInfoTable.PrintDataSetName);

                foreach (var layout in subject.LayoutElements)
                {

                    var layoutElem = new XElement(IllustLayoutInfoTable.PrintDataTableName);
                    layoutElem.Add(layout.Elements(IllustLayoutInfoTable.Id));
                    layoutElem.Add(layout.Elements(IllustLayoutInfoTable.Year));
                    layoutElem.Add(layout.Elements(IllustLayoutInfoTable.Name));
                    layoutElem.Add(layout.Elements(IllustLayoutInfoTable.illust));
                    layoutElem.Add(layout.Elements(IllustLayoutInfoTable.label));
                    rootElem.Add(layoutElem);
                }
                doc.Add(rootElem);

                var writer = new XmlTextWriter(FilePathDataBase.getPrintoutIllustLayoutFilePath(), Encoding.UTF8);
                writer.Formatting = Formatting.Indented;
                doc.WriteTo(writer);
                writer.Close();
                doc = null;
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
            }
        }

        #endregion

    }
}
