﻿using System;
using System.Collections.Generic;
using System.Xml.Linq;
using Hitsuji.Framework.ObserverPattern.Observers;
using Hitsuji.Framework.ObserverPattern.Subjects;
using Hitsuji.Framework.ViewModels;
using Hitsuji.Nengajou.ObserverPattern.Subjects;
using Hitsuji.Nengajou.ViewModels;
using Hitsuji.Nengajou.ViewModels.LayoutListViewItems;
using Hitsuji.Nengajou.Views;
using Hitsuji.Nengajou.Views.LayoutListViewItems;

namespace Hitsuji.Nengajou.ObserverPattern.Observers
{
    public class ReflectUILayoutListViewAsIllustObserver : IObserver, IReflectUIObserver
    {
        #region IObserver メンバ

        public void doMyRole(ASubject aSubject)
        {
            try
            {
                GetIllustLayoutInfoSubject subject = (GetIllustLayoutInfoSubject)aSubject;

                var vmDictionary = ViewModelManager.getInstance();
                var layoutListVM = vmDictionary["LayoutListViewModel"] as LayoutListViewModel;
                var layoutListV = layoutListVM.View as LayoutListView;

                List<ReseiverLayoutItemView> items = new List<ReseiverLayoutItemView>();
                foreach (XElement layoutElem in subject.LayoutElements)
                {
                    var itemV = new ReseiverLayoutItemView();
                    var itemVM = new LayoutItemViewModel();
                    itemV.DataContext = itemVM;
                    itemVM.Id = layoutElem.Element("ID").Value;
                    itemVM.LayoutName = layoutElem.Element("NAME").Value;
                    itemVM.LayoutElement = layoutElem;
                    items.Add(itemV);
                }

                //新規登録用のアイテム追加
                items.Add(new ReseiverLayoutItemView());

                layoutListV.listBox1.ItemsSource = null;
                layoutListV.listBox1.Items.Clear();
                layoutListV.listBox1.ItemsSource = items;

            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
            }
        }

        #endregion

        #region IReflectUIObserver メンバ

        public void setRefViewModel(AViewModel vm)
        {
            throw new NotImplementedException();
        }

        public void reflectUi(List<Action> dispatchActionList)
        {
            throw new NotImplementedException();
        }

        #endregion
    }
}
