﻿using System;
using System.Collections.Generic;
using System.Windows;
using Hitsuji.Framework.ObserverPattern.Observers;
using Hitsuji.Framework.ObserverPattern.Subjects;
using Hitsuji.Framework.ViewModels;
using Hitsuji.Nengajou.Models.Contents;
using Hitsuji.Nengajou.ObserverPattern.Subjects;
using Hitsuji.Nengajou.Views;

namespace Hitsuji.Nengajou.ObserverPattern.Observers
{
    public class ReflectUIPrimaryListViewAsOtherPersonalObserver : IObserver, IReflectUIObserver
    {
        #region IObserver メンバ

        public void doMyRole(ASubject aSubject)
        {
            try
            {
                Subject subject = (Subject)aSubject;
                var otherPersonalList = (ContentModelList)subject.models["infoList"];
                var primaryInfoListBoxView = (PrimaryListView)ViewModelManager.getInstance()["PrimaryListViewModel"].View;

                //新規登録用のアイテムを追加
                otherPersonalList.addContentModel(new OtherPersonalInfoContentModel());
                Action updateListItemsSourceDelegate = delegate() { primaryInfoListBoxView.listBox1.ItemsSource = otherPersonalList; };
                Action updateListItemTemplateDelegate = delegate() { primaryInfoListBoxView.listBox1.ItemTemplate = (DataTemplate)primaryInfoListBoxView.FindResource("OtherPersonalInfoDataTemplate"); };
                primaryInfoListBoxView.Dispatcher.Invoke(updateListItemsSourceDelegate);
                primaryInfoListBoxView.Dispatcher.Invoke(updateListItemTemplateDelegate);
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
            }
        }

        #endregion

        #region IReflectUIObserver メンバ

        public void setRefViewModel(AViewModel vm)
        {
            throw new NotImplementedException();
        }

        public void reflectUi(List<Action> dispatchActionList)
        {
            throw new NotImplementedException();
        }

        #endregion
    }
}
