﻿using System;
using System.Linq;
using System.Xml.Linq;
using Hitsuji.Nengajou.Models.Contents;
using Hitsuji.Nengajou.Models.DataBases;

namespace Hitsuji.Nengajou.ObserverPattern.Subjects
{
    public class GetGroupInfoSubject : Subject
    {
        public bool enableParam = true;

        public void doMyRole()
        {
            try
            {
                //抽出処理開始
                XDocument groupDoc = XDocument.Load(FilePathDataBase.getGroupFilePath());
                var query = from g in groupDoc.Descendants(GroupInfoTable.DataTableName)
                            select new
                            {
                                groupId = g.Element(GroupInfoTable.Id),
                                groupEnable = g.Element(GroupInfoTable.Enable),
                                groupName = g.Element(GroupInfoTable.Name)
                            };

                var list = new ContentModelList();
                foreach (var data in query)
                {
                    var groupModel = new GroupInfoContentModel();
                    groupModel.Id = data.groupId.Value;
                    groupModel.Enable = bool.Parse(data.groupEnable.Value);
                    groupModel.Name = data.groupName.Value;
                    list.addContentModel(groupModel);
                }

                query = null;
                groupDoc = null;
                models.Add("infoList", list);

            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
            }

            notify(this);

        }
    }
}
