﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Xml.Linq;
using Hitsuji.Nengajou.Models.DataBases;

namespace Hitsuji.Nengajou.ObserverPattern.Subjects
{
    public class GetIllustLayoutInfoSubject : Subject
    {
        public IEnumerable<XElement> LayoutElements;

        public string yearParam = "";

        public void doMyRole()
        {
            try
            {
                //抽出処理開始
                var textAll = File.ReadAllText(FilePathDataBase.getIllustLayoutFilePath());
                var doc = XElement.Parse(textAll);
                LayoutElements = from n in doc.Descendants(IllustLayoutInfoTable.DataTableName)
                                 //where n.Element("ENABLE").Value.StartsWith(enableParam.ToString())
                                 where n.Element(IllustLayoutInfoTable.Year).Value.StartsWith(yearParam)
                                 select n;

                doc = null;

            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
            }
            
            notify(this);
        }
    }
}
