﻿using System;
using System.IO;
using System.Data;
using System.Collections.Generic;
using System.Linq;
using System.Xml;
using System.Xml.Linq;
using System.Text;
//using Hitsuji.Nengajou.Model.Dao.Xml;
using Hitsuji.Framework.Data;
using Hitsuji.Framework.Directories;
using Hitsuji.Nengajou.Model.Contents;
using Hitsuji.Nengajou.Model.DataBases;

namespace Hitsuji.Nengajou.ObserverPattern.Subjects
{
    public class GetPostInfoSubject : Subject
    {
        public bool enableParam = true;

        public void doMyRole()
        {
            var textAll = File.ReadAllText(FilePathDataBase.getPostFilePath());
            var doc = XElement.Parse(textAll);
            var query = from n in doc.Descendants("POST")
                        where n.Element("ENABLE").Value.StartsWith(enableParam.ToString())
                        select n;

            var list = new ContentModelList();
            foreach (var elem in query)
            {
                var contentModel = new PostInfoContentModel();
                contentModel.Id = elem.Element("ID").Value;
                contentModel.Enable = bool.Parse(elem.Element("ENABLE").Value);
                contentModel.PNoPre1 = elem.Element("PRIM1").Value;
                contentModel.PNoPre2 = elem.Element("PRIM2").Value;
                contentModel.PNoPre3 = elem.Element("PRIM3").Value;
                contentModel.PNoPost1 = elem.Element("SECO1").Value;
                contentModel.PNoPost2 = elem.Element("SECO2").Value;
                contentModel.PNoPost3 = elem.Element("SECO3").Value;
                contentModel.PNoPost4 = elem.Element("SECO4").Value;
                contentModel.Address1 = elem.Element("ADDRESS1").Value;
                contentModel.Address2 = elem.Element("ADDRESS2").Value;
                list.addContentModel(contentModel);
            }

            query = null;
            doc = null;

            models.Add("infoList", list);

            notify(this);
        }
    }
}
