﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Xml.Linq;
using Hitsuji.Nengajou.Models.Contents;
using Hitsuji.Nengajou.Models.DataBases;

namespace Hitsuji.Nengajou.ObserverPattern.Subjects
{
    public class GetReseiverLayoutInfoForPrintoutSubject : Subject
    {
        public bool reseiverLayoutEnebleParam_ = true;
        public bool personalEnableParam_ = true;
        public IEnumerable<XElement> reseiverLayoutElements;
        public IEnumerable<XElement> personElements;

        public void doMyRole()
        {
            try
            {
                //出力情報取得
                XDocument groupDoc = XDocument.Load(FilePathDataBase.getGroupFilePath());
                XDocument personDoc = XDocument.Load(FilePathDataBase.getOtherPersonalFilePath());
                XDocument myDoc = XDocument.Load(FilePathDataBase.getMyPersonalFilePath());
                var query = from p in personDoc.Descendants(PersonalInfoTable.DataTableName)
                            join g in groupDoc.Descendants(GroupInfoTable.DataTableName)
                                on (string)p.Element(PersonalInfoTable.GroupKey) equals (string)g.Element(GroupInfoTable.Id)
                            join m in myDoc.Descendants(PersonalInfoTable.DataTableName)
                                on (string)p.Element(PersonalInfoTable.SenderKey) equals (string)m.Element(PersonalInfoTable.Id)
                            where p.Element(PersonalInfoTable.Enable).Value.Equals(personalEnableParam_.ToString())
                            select new
                            {
                                reseiverId = p.Element(PersonalInfoTable.Id),
                                reseiverPrim1 = p.Element(PersonalInfoTable.PNoPre1),
                                reseiverPrim2 = p.Element(PersonalInfoTable.PNoPre2),
                                reseiverPrim3 = p.Element(PersonalInfoTable.PNoPre3),
                                reseiverSeco1 = p.Element(PersonalInfoTable.PNoPost1),
                                reseiverSeco2 = p.Element(PersonalInfoTable.PNoPost2),
                                reseiverSeco3 = p.Element(PersonalInfoTable.PNoPost3),
                                reseiverSeco4 = p.Element(PersonalInfoTable.PNoPost4),
                                reseiverAddress1 = p.Element(PersonalInfoTable.Address1),
                                reseiverAddress2 = p.Element(PersonalInfoTable.Address2),
                                reseiverAddress3 = p.Element(PersonalInfoTable.Address3),
                                reseiverName1 = p.Element(PersonalInfoTable.Name1),
                                reseiverName2 = p.Element(PersonalInfoTable.Name2),
                                reseiverName3 = p.Element(PersonalInfoTable.Name3),
                                reseiverName4 = p.Element(PersonalInfoTable.Name4),
                                reseiverNPF1 = p.Element(PersonalInfoTable.NPF1),
                                reseiverNPF2 = p.Element(PersonalInfoTable.NPF2),
                                reseiverNPF3 = p.Element(PersonalInfoTable.NPF3),
                                reseiverNPF4 = p.Element(PersonalInfoTable.NPF4),
                                groupId = p.Element(PersonalInfoTable.GroupKey),
                                 groupName = g.Element(GroupInfoTable.Name),
                                senderId = p.Element(PersonalInfoTable.SenderKey),
                                reseiverLayoutId = p.Element(PersonalInfoTable.ReseiverLayoutKey),
                                senderPrim1 = m.Element(PersonalInfoTable.PNoPre1),
                                senderPrim2 = m.Element(PersonalInfoTable.PNoPre2),
                                senderPrim3 = m.Element(PersonalInfoTable.PNoPre3),
                                senderPost1 = m.Element(PersonalInfoTable.PNoPost1),
                                senderPost2 = m.Element(PersonalInfoTable.PNoPost2),
                                senderPost3 = m.Element(PersonalInfoTable.PNoPost3),
                                senderPost4 = m.Element(PersonalInfoTable.PNoPost4),
                                senderAddress1 = m.Element(PersonalInfoTable.Address1),
                                senderAddress2 = m.Element(PersonalInfoTable.Address2),
                                senderAddress3 = m.Element(PersonalInfoTable.Address3),
                                senderName1 = m.Element(PersonalInfoTable.Name1),
                                senderName2 = m.Element(PersonalInfoTable.Name2),
                                senderName3 = m.Element(PersonalInfoTable.Name3),
                                senderName4 = m.Element(PersonalInfoTable.Name4),
                                senderTel = m.Element(PersonalInfoTable.Tel)
                            };

                var list = new ContentModelList();
                foreach (var data in query)
                {
                    var printReseiverLayoutInfo = new PrintReseiverLayoutInfoContentModel();
                    printReseiverLayoutInfo.ReseiverId = data.reseiverId.Value;
                    printReseiverLayoutInfo.ReseiverPrim1 = data.reseiverPrim1.Value;
                    printReseiverLayoutInfo.ReseiverPrim2 = data.reseiverPrim2.Value;
                    printReseiverLayoutInfo.ReseiverPrim3 = data.reseiverPrim3.Value;
                    printReseiverLayoutInfo.ReseiverPost1 = data.reseiverSeco1.Value;
                    printReseiverLayoutInfo.ReseiverPost2 = data.reseiverSeco2.Value;
                    printReseiverLayoutInfo.ReseiverPost3 = data.reseiverSeco3.Value;
                    printReseiverLayoutInfo.ReseiverPost4 = data.reseiverSeco4.Value;
                    printReseiverLayoutInfo.ReseiverAddress1 = data.reseiverAddress1.Value;
                    printReseiverLayoutInfo.ReseiverAddress2 = data.reseiverAddress2.Value;
                    printReseiverLayoutInfo.ReseiverAddress3 = data.reseiverAddress3.Value;
                    printReseiverLayoutInfo.ReseiverName1 = data.reseiverName1.Value;
                    printReseiverLayoutInfo.ReseiverName2 = data.reseiverName2.Value;
                    printReseiverLayoutInfo.ReseiverName3 = data.reseiverName3.Value;
                    printReseiverLayoutInfo.ReseiverName4 = data.reseiverName4.Value;
                    printReseiverLayoutInfo.ReseiverNPF1 = data.reseiverNPF1.Value;
                    printReseiverLayoutInfo.ReseiverNPF2 = data.reseiverNPF2.Value;
                    printReseiverLayoutInfo.ReseiverNPF3 = data.reseiverNPF3.Value;
                    printReseiverLayoutInfo.ReseiverNPF4 = data.reseiverNPF4.Value;
                    printReseiverLayoutInfo.GroupId = data.groupId.Value;
                    printReseiverLayoutInfo.ReseiverLayoutId = data.reseiverLayoutId.Value;
                    printReseiverLayoutInfo.SenderId = data.senderId.Value;
                    printReseiverLayoutInfo.SenderPrim1 = data.senderPrim1.Value;
                    printReseiverLayoutInfo.SenderPrim2 = data.senderPrim2.Value;
                    printReseiverLayoutInfo.SenderPrim3 = data.senderPrim3.Value;
                    printReseiverLayoutInfo.SenderPost1 = data.senderPost1.Value;
                    printReseiverLayoutInfo.SenderPost2 = data.senderPost2.Value;
                    printReseiverLayoutInfo.SenderPost3 = data.senderPost3.Value;
                    printReseiverLayoutInfo.SenderPost4 = data.senderPost4.Value;
                    printReseiverLayoutInfo.SenderAddress1 = data.senderAddress1.Value;
                    printReseiverLayoutInfo.SenderAddress2 = data.senderAddress2.Value;
                    printReseiverLayoutInfo.SenderAddress3 = data.senderAddress3.Value;
                    printReseiverLayoutInfo.SenderName1 = data.senderName1.Value;
                    printReseiverLayoutInfo.SenderName2 = data.senderName2.Value;
                    printReseiverLayoutInfo.SenderName3 = data.senderName3.Value;
                    printReseiverLayoutInfo.SenderName4 = data.senderName4.Value;
                    printReseiverLayoutInfo.SenderTel = data.senderTel.Value;
                    list.addContentModel(printReseiverLayoutInfo);
                }
                personDoc = null;
                groupDoc = null;
                myDoc = null;
                models.Add("infoList", list);

                //レイアウト情報取得
                XDocument rlDoc = XDocument.Load(FilePathDataBase.getReseiverLayoutFilePath());
                reseiverLayoutElements = from p in rlDoc.Descendants(ReseiverLayoutInfoTable.DataTableName)
                                         //where p.Element("ENABLE").Value.StartsWith(reseiverLayoutEnebleParam_.ToString())
                                         select p;
                
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
            }

            notify(this);

        }
    }
}
