﻿using System;
using Hitsuji.Framework.ViewModels;
using Hitsuji.Nengajou.Models.Contents;
using Hitsuji.Nengajou.ObserverPattern.Observers;
using Hitsuji.Nengajou.ObserverPattern.Subjects;
using Hitsuji.Nengajou.Views;

namespace Hitsuji.Nengajou.ViewModels
{
    public class FontFamilyInputViewModel : AViewModel
    {
        public FontFamilyInfoContentModel FontFamilyInfo
        {
            get;
            set;
        }

        public FontFamilyInputViewModel()
        {
            this.FontFamilyInfo = ContentModelFactory.createFontFamilyContentModel();
            this.FontFamilyInfo.canExeDelegate_ = this.canExecuteMethod;
            this.FontFamilyInfo.exeDelegate_ = this.executeMethod;
        }

        //コマンド canExecute
        protected bool canExecuteMethod()
        {
            return !string.IsNullOrEmpty(FontFamilyInfo.FontFamilyName);
        }


        //コマンド Execute
        protected void executeMethod()
        {
            try
            {
                var subject = new GetFontFamilyInfoSubject();
                var updateObserver = new UpdateFontFamilyDataSourceObserver();
                subject.models.Add(this.FontFamilyInfo.GetType().Name, this.FontFamilyInfo);
                subject.addObserver(updateObserver);
                subject.doMyRole();

                //強制的にビュー更新
                var primaryMenuVM = ViewModelManager.getInstance()["PrimaryMenuViewModel"] as PrimaryMenuViewModel;
                primaryMenuVM.onFontFamilyMenuClicked();
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
            }
        }
    }
}
