﻿using System;
using System.Collections.Generic;
using System.Windows;
using Hitsuji.Framework.ViewModels;
using Hitsuji.Nengajou.Views;

namespace Hitsuji.Nengajou.ViewModels
{
    public class PrimaryListViewModel : AViewModel
    {
        //スタックパネルのアイテムを全てクリア
        public void clearStackPanelItems()
        {
            (this.View as PrimaryAreaBaseView).stackPanel1.Children.Clear();
        }


        public Action<object> OnSelectedItemChangedDelegate
        {
            get;
            set;
        }

        //スタックパネルにアイテム追加
        public void addStackPanelItem(UIElement view)
        {
            (this.View as PrimaryAreaBaseView).stackPanel1.Children.Add(view);

        }

        //ソースセット
        public void setItemsSource(List<MyPersonalInputView> itemsSource)
        {
            (this.View as PrimaryListView).listBox1.ItemsSource = itemsSource;
        }

        //アイテム選択時
        public void onSelectionItemChanged(object selectedItem)
        {
            if (OnSelectedItemChangedDelegate != null &&
                selectedItem != null)
            {
                OnSelectedItemChangedDelegate(selectedItem);
            }
        }

    }
}
