﻿using System;
using System.Windows.Controls;
using System.Windows.Media;
using Hitsuji.Framework.Thread;
using Hitsuji.Framework.ViewModels;
using Hitsuji.Nengajou.Models.Contents;
using Hitsuji.Nengajou.ObserverPattern.Observers;
using Hitsuji.Nengajou.ObserverPattern.Subjects;
using Hitsuji.Nengajou.Views;

namespace Hitsuji.Nengajou.ViewModels
{
    public class PrimaryMenuViewModel : AViewModel
    {
        
        //My情報
        public void onMyPersonalInfoMenuClicked()
        {
            try
            {
                //プライマリービュー上のオブジェクト変更
                var vmDictionary = ViewModelManager.getInstance();
                
                var primaryAreaBaseVM = vmDictionary["PrimaryAreaBaseViewModel"] as PrimaryAreaBaseViewModel;
                primaryAreaBaseVM.clearStackPanelItems();
                primaryAreaBaseVM.addStackPanelItem(vmDictionary["MyPersonalInputViewModel"].View);
                primaryAreaBaseVM.addStackPanelItem(vmDictionary["PrimaryListViewModel"].View);
                //リストアイテム選択時の処理を登録
                var primaryVM = vmDictionary["PrimaryListViewModel"] as PrimaryListViewModel;
                primaryVM.OnSelectedItemChangedDelegate = delegate(object selectedItem)
                {
                    //MyPersonalInfoInputVM のデータコンテンツモデル値の更新処理を登録
                    var myPersonalInputVM = ViewModelManager.getInstance()["MyPersonalInputViewModel"] as MyPersonalInputViewModel;
                    (myPersonalInputVM.MyPersonalContentInfo as MyPersonalInfoContentModel).Id = (selectedItem as MyPersonalInfoContentModel).Id;
                    (myPersonalInputVM.MyPersonalContentInfo as MyPersonalInfoContentModel).Enable = (selectedItem as MyPersonalInfoContentModel).Enable;
                    (myPersonalInputVM.MyPersonalContentInfo as MyPersonalInfoContentModel).GroupKey = (selectedItem as MyPersonalInfoContentModel).GroupKey;
                    (myPersonalInputVM.MyPersonalContentInfo as MyPersonalInfoContentModel).GroupName = (selectedItem as MyPersonalInfoContentModel).GroupName;
                    (myPersonalInputVM.MyPersonalContentInfo as MyPersonalInfoContentModel).PNoPre1 = (selectedItem as MyPersonalInfoContentModel).PNoPre1;
                    (myPersonalInputVM.MyPersonalContentInfo as MyPersonalInfoContentModel).PNoPre2 = (selectedItem as MyPersonalInfoContentModel).PNoPre2;
                    (myPersonalInputVM.MyPersonalContentInfo as MyPersonalInfoContentModel).PNoPre3 = (selectedItem as MyPersonalInfoContentModel).PNoPre3;
                    (myPersonalInputVM.MyPersonalContentInfo as MyPersonalInfoContentModel).PNoPost1 = (selectedItem as MyPersonalInfoContentModel).PNoPost1;
                    (myPersonalInputVM.MyPersonalContentInfo as MyPersonalInfoContentModel).PNoPost2 = (selectedItem as MyPersonalInfoContentModel).PNoPost2;
                    (myPersonalInputVM.MyPersonalContentInfo as MyPersonalInfoContentModel).PNoPost3 = (selectedItem as MyPersonalInfoContentModel).PNoPost3;
                    (myPersonalInputVM.MyPersonalContentInfo as MyPersonalInfoContentModel).PNoPost4 = (selectedItem as MyPersonalInfoContentModel).PNoPost4;
                    (myPersonalInputVM.MyPersonalContentInfo as MyPersonalInfoContentModel).Name1 = (selectedItem as MyPersonalInfoContentModel).Name1;
                    (myPersonalInputVM.MyPersonalContentInfo as MyPersonalInfoContentModel).Name2 = (selectedItem as MyPersonalInfoContentModel).Name2;
                    (myPersonalInputVM.MyPersonalContentInfo as MyPersonalInfoContentModel).Name3 = (selectedItem as MyPersonalInfoContentModel).Name3;
                    (myPersonalInputVM.MyPersonalContentInfo as MyPersonalInfoContentModel).Name4 = (selectedItem as MyPersonalInfoContentModel).Name4;
                    (myPersonalInputVM.MyPersonalContentInfo as MyPersonalInfoContentModel).Address1 = (selectedItem as MyPersonalInfoContentModel).Address1;
                    (myPersonalInputVM.MyPersonalContentInfo as MyPersonalInfoContentModel).Address2 = (selectedItem as MyPersonalInfoContentModel).Address2;
                    (myPersonalInputVM.MyPersonalContentInfo as MyPersonalInfoContentModel).Address3 = (selectedItem as MyPersonalInfoContentModel).Address3;
                    (myPersonalInputVM.MyPersonalContentInfo as MyPersonalInfoContentModel).Tel = (selectedItem as MyPersonalInfoContentModel).Tel;

                };

                //リストデータの抽出・表示
                using (PrepareThreadUtil prepareThread = new PrepareThreadUtil())
                {
                    var getSubject = new GetMyPersonalInfoSubject();
                    var reflectUIPrimaryListBoxViewObserver = new ReflectUIPrimaryListViewAsMyPersonalObserver();

                    getSubject.addObserver(reflectUIPrimaryListBoxViewObserver);
                    prepareThread.prepare("Thread:GetMyPersonalInfos", getSubject.doMyRole);
                    prepareThread.threadStart();
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
            }
        }


        //他者情報
        public void onOtherPersonalMenuClicked()
        {
            try
            {
                //プライマリービュー上のオブジェクト変更
                var vmDictionary = ViewModelManager.getInstance();
                var primaryAreaBaseVM = vmDictionary["PrimaryAreaBaseViewModel"] as PrimaryAreaBaseViewModel;
                primaryAreaBaseVM.clearStackPanelItems();
                primaryAreaBaseVM.addStackPanelItem(vmDictionary["OtherPersonalInputViewModel"].View);
                primaryAreaBaseVM.addStackPanelItem(vmDictionary["PrimaryListViewModel"].View);
                
                //リストアイテム選択時の処理を登録
                var primaryVM = vmDictionary["PrimaryListViewModel"] as PrimaryListViewModel;
                primaryVM.OnSelectedItemChangedDelegate = delegate(object selectedItem)
                {
                    //MyPersonalInfoInputVM のデータコンテンツモデル値の更新処理を登録
                    var otherPersonalInputVM = ViewModelManager.getInstance()["OtherPersonalInputViewModel"] as OtherPersonalInputViewModel;
                    (otherPersonalInputVM.OtherPersonalContentInfo as OtherPersonalInfoContentModel).Id = (selectedItem as OtherPersonalInfoContentModel).Id;
                    (otherPersonalInputVM.OtherPersonalContentInfo as OtherPersonalInfoContentModel).Enable = (selectedItem as OtherPersonalInfoContentModel).Enable;
                    (otherPersonalInputVM.OtherPersonalContentInfo as OtherPersonalInfoContentModel).GroupKey = (selectedItem as OtherPersonalInfoContentModel).GroupKey;
                    (otherPersonalInputVM.OtherPersonalContentInfo as OtherPersonalInfoContentModel).GroupName = (selectedItem as OtherPersonalInfoContentModel).GroupName;
                    (otherPersonalInputVM.OtherPersonalContentInfo as OtherPersonalInfoContentModel).PNoPre1 = (selectedItem as OtherPersonalInfoContentModel).PNoPre1;
                    (otherPersonalInputVM.OtherPersonalContentInfo as OtherPersonalInfoContentModel).PNoPre2 = (selectedItem as OtherPersonalInfoContentModel).PNoPre2;
                    (otherPersonalInputVM.OtherPersonalContentInfo as OtherPersonalInfoContentModel).PNoPre3 = (selectedItem as OtherPersonalInfoContentModel).PNoPre3;
                    (otherPersonalInputVM.OtherPersonalContentInfo as OtherPersonalInfoContentModel).PNoPost1 = (selectedItem as OtherPersonalInfoContentModel).PNoPost1;
                    (otherPersonalInputVM.OtherPersonalContentInfo as OtherPersonalInfoContentModel).PNoPost2 = (selectedItem as OtherPersonalInfoContentModel).PNoPost2;
                    (otherPersonalInputVM.OtherPersonalContentInfo as OtherPersonalInfoContentModel).PNoPost3 = (selectedItem as OtherPersonalInfoContentModel).PNoPost3;
                    (otherPersonalInputVM.OtherPersonalContentInfo as OtherPersonalInfoContentModel).PNoPost4 = (selectedItem as OtherPersonalInfoContentModel).PNoPost4;
                    (otherPersonalInputVM.OtherPersonalContentInfo as OtherPersonalInfoContentModel).Address1 = (selectedItem as OtherPersonalInfoContentModel).Address1;
                    (otherPersonalInputVM.OtherPersonalContentInfo as OtherPersonalInfoContentModel).Address2 = (selectedItem as OtherPersonalInfoContentModel).Address2;
                    (otherPersonalInputVM.OtherPersonalContentInfo as OtherPersonalInfoContentModel).Address3 = (selectedItem as OtherPersonalInfoContentModel).Address3;
                    (otherPersonalInputVM.OtherPersonalContentInfo as OtherPersonalInfoContentModel).Name1 = (selectedItem as OtherPersonalInfoContentModel).Name1;
                    (otherPersonalInputVM.OtherPersonalContentInfo as OtherPersonalInfoContentModel).Name2 = (selectedItem as OtherPersonalInfoContentModel).Name2;
                    (otherPersonalInputVM.OtherPersonalContentInfo as OtherPersonalInfoContentModel).Name3 = (selectedItem as OtherPersonalInfoContentModel).Name3;
                    (otherPersonalInputVM.OtherPersonalContentInfo as OtherPersonalInfoContentModel).Name4 = (selectedItem as OtherPersonalInfoContentModel).Name4;
                    (otherPersonalInputVM.OtherPersonalContentInfo as OtherPersonalInfoContentModel).NPF1 = (selectedItem as OtherPersonalInfoContentModel).NPF1;
                    (otherPersonalInputVM.OtherPersonalContentInfo as OtherPersonalInfoContentModel).NPF2 = (selectedItem as OtherPersonalInfoContentModel).NPF2;
                    (otherPersonalInputVM.OtherPersonalContentInfo as OtherPersonalInfoContentModel).NPF3 = (selectedItem as OtherPersonalInfoContentModel).NPF3;
                    (otherPersonalInputVM.OtherPersonalContentInfo as OtherPersonalInfoContentModel).NPF4 = (selectedItem as OtherPersonalInfoContentModel).NPF4;
                    (otherPersonalInputVM.OtherPersonalContentInfo as OtherPersonalInfoContentModel).SenderKey = (selectedItem as OtherPersonalInfoContentModel).SenderKey;
                    (otherPersonalInputVM.OtherPersonalContentInfo as OtherPersonalInfoContentModel).ReseiverLayoutKey = (selectedItem as OtherPersonalInfoContentModel).ReseiverLayoutKey;
                    (otherPersonalInputVM.OtherPersonalContentInfo as OtherPersonalInfoContentModel).ReseiverLayoutName = (selectedItem as OtherPersonalInfoContentModel).ReseiverLayoutName;

                    //UIのグループ選択コンボボックス値を更新
                    var getGroupSubject = new GetGroupInfoSubject();
                    getGroupSubject.doMyRole();

                };

                //リストデータの抽出・表示
                using (PrepareThreadUtil prepareThread = new PrepareThreadUtil())
                {
                    var getSubject = new GetOtherPersonalInfoSubject();
                    var reflectUIPrimaryListBoxViewObserver = new ReflectUIPrimaryListViewAsOtherPersonalObserver();

                    getSubject.addObserver(reflectUIPrimaryListBoxViewObserver);
                    prepareThread.prepare("Thread:GetOtherPersonalInfos", getSubject.doMyRole);
                    prepareThread.threadStart();
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
            }
        }


        //グループ情報
        public void onGroupMenuClicked()
        {
            try
            {
                //プライマリービュー上のオブジェクト変更
                var vmDictionary = ViewModelManager.getInstance();
                //PrimaryAreaBaseViewModel primaryAreaBaseVM = ViewModelCollection.getInstance()["PrimaryAreaBaseViewModel"] as PrimaryAreaBaseViewModel;
                var primaryAreaBaseVM = vmDictionary["PrimaryAreaBaseViewModel"] as PrimaryAreaBaseViewModel;
                primaryAreaBaseVM.clearStackPanelItems();
                //primaryAreaBaseVM.addStackPanelItem(ViewModelCollection.getViewModelFromCollection(new GroupInputView(), new GroupInputViewModel()).View);
                //primaryAreaBaseVM.addStackPanelItem(ViewModelCollection.getViewModelFromCollection(new PrimaryListView(), new PrimaryListViewModel()).View);
                primaryAreaBaseVM.addStackPanelItem(vmDictionary["GroupInputViewModel"].View);
                primaryAreaBaseVM.addStackPanelItem(vmDictionary["PrimaryListViewModel"].View);
                
                //リストアイテム選択時の処理を登録
                //var primaryVM = ViewModelCollection.getInstance()["PrimaryListViewModel"] as PrimaryListViewModel;
                var primaryVM = vmDictionary["PrimaryListViewModel"] as PrimaryListViewModel;
                primaryVM.OnSelectedItemChangedDelegate = delegate(object selectedItem)
                {
                    //MyPersonalInfoInputVM のデータコンテンツモデル値の更新処理を登録
                    //var groupInfoInputVM = ViewModelCollection.getInstance()["GroupInputViewModel"] as GroupInputViewModel;
                    var groupInputVM = ViewModelManager.getInstance()["GroupInputViewModel"] as GroupInputViewModel;
                    (groupInputVM.GroupContentInfo as GroupInfoContentModel).Id = (selectedItem as GroupInfoContentModel).Id;
                    (groupInputVM.GroupContentInfo as GroupInfoContentModel).Enable = (selectedItem as GroupInfoContentModel).Enable;
                    (groupInputVM.GroupContentInfo as GroupInfoContentModel).Name = (selectedItem as GroupInfoContentModel).Name;

                };

                //リストデータの抽出・表示
                using (PrepareThreadUtil prepareThread = new PrepareThreadUtil())
                {
                    var getSubject = new GetGroupInfoSubject();
                    var reflectUIPrimaryListBoxViewObserver = new ReflectUIPrimaryListViewAsGroupObserver();

                    getSubject.addObserver(reflectUIPrimaryListBoxViewObserver);
                    prepareThread.prepare("Thread:GetGroupInfos", getSubject.doMyRole);
                    prepareThread.threadStart();
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
            }
        }


        //年
        public void onYearMenuClicked()
        {
            try
            {
                //プライマリービュー上のオブジェクト変更
                var vmDictionary = ViewModelManager.getInstance();
                var primaryAreaBaseVM = vmDictionary["PrimaryAreaBaseViewModel"] as PrimaryAreaBaseViewModel;
                primaryAreaBaseVM.clearStackPanelItems();
                primaryAreaBaseVM.addStackPanelItem(vmDictionary["YearInputViewModel"].View);
                primaryAreaBaseVM.addStackPanelItem(vmDictionary["PrimaryListViewModel"].View);
                
                //リストアイテム選択時の処理を登録
                var primaryVM = vmDictionary["PrimaryListViewModel"] as PrimaryListViewModel;
                primaryVM.OnSelectedItemChangedDelegate = delegate(object selectedItem)
                {
                    //MyPersonalInfoInputVM のデータコンテンツモデル値の更新処理を登録
                    var yearInputVM = ViewModelManager.getInstance()["YearInputViewModel"] as YearInputViewModel;
                    (yearInputVM.YearContentInfo as YearInfoContentModel).Id = (selectedItem as YearInfoContentModel).Id;
                    (yearInputVM.YearContentInfo as YearInfoContentModel).Enable = (selectedItem as YearInfoContentModel).Enable;
                    (yearInputVM.YearContentInfo as YearInfoContentModel).Value = (selectedItem as YearInfoContentModel).Value;
                };

                //リストデータの抽出・表示
                using (PrepareThreadUtil prepareThread = new PrepareThreadUtil())
                {
                    var getSubject = new GetYearInfoSubject();
                    var reflectUIPrimaryListBoxViewObserver = new ReflectUIPrimaryListViewAsYearObserver();

                    getSubject.addObserver(reflectUIPrimaryListBoxViewObserver);
                    prepareThread.prepare("Thread:GetYearInfos", getSubject.doMyRole);
                    prepareThread.threadStart();
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
            }
        }


        //フォントファミリ
        public void onFontFamilyMenuClicked()
        {
            try
            {
                //プライマリービュー上のオブジェクト変更
                var vmDictionary = ViewModelManager.getInstance();
                var primaryAreaBaseVM = vmDictionary["PrimaryAreaBaseViewModel"] as PrimaryAreaBaseViewModel;
                primaryAreaBaseVM.clearStackPanelItems();
                primaryAreaBaseVM.addStackPanelItem(vmDictionary["FontFamilyInputViewModel"].View);
                primaryAreaBaseVM.addStackPanelItem(vmDictionary["PrimaryListViewModel"].View);
                
                //リストアイテム選択時の処理を登録
                var primaryVM = vmDictionary["PrimaryListViewModel"] as PrimaryListViewModel;
                primaryVM.OnSelectedItemChangedDelegate = delegate(object selectedItem)
                {
                    //MyPersonalInfoInputVM のデータコンテンツモデル値の更新処理を登録
                    var fontFamilyInfoInputVM = ViewModelManager.getInstance()["FontFamilyInputViewModel"] as FontFamilyInputViewModel;
                    (fontFamilyInfoInputVM.FontFamilyInfo as FontFamilyInfoContentModel).Id = (selectedItem as FontFamilyInfoContentModel).Id;
                    (fontFamilyInfoInputVM.FontFamilyInfo as FontFamilyInfoContentModel).Enable = (selectedItem as FontFamilyInfoContentModel).Enable;
                    (fontFamilyInfoInputVM.FontFamilyInfo as FontFamilyInfoContentModel).FontFamilyName = (selectedItem as FontFamilyInfoContentModel).FontFamilyName;
                };

                //リストデータの抽出・表示
                using (PrepareThreadUtil prepareThread = new PrepareThreadUtil())
                {
                    var getSubject = new GetFontFamilyInfoSubject();
                    var reflectUIPrimaryListBoxViewObserver = new ReflectUIPrimaryListViewAsFontFamilyObserver();
                    getSubject.addObserver(reflectUIPrimaryListBoxViewObserver);
                    prepareThread.prepare("Thread:GetFontFamilyInfos", getSubject.doMyRole);
                    prepareThread.threadStart();
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
            }
        }


        //選択されたメニューアイテムの背景色を変更。
        //そのほかのメニューアイテムの背景色は元の色に戻す。
        public void setMenuItemsBackgroundBrush(MenuItem sender)
        {
            foreach (MenuItem item in (this.View as PrimaryMenuView).menu1.Items)
            {
                item.Background = Brushes.Silver;
            }
            sender.Background = Brushes.SlateGray;
        }
    }
}
