﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Hitsuji.Framework.ViewModels;
using Hitsuji.Nengajou.ViewModels;
using Hitsuji.Nengajou.Models.InnerCanvasStateModels;

namespace Hitsuji.Nengajou.Views
{
    /// <summary>
    /// IllustLayoutView.xaml の相互作用ロジック
    /// </summary>
    public partial class IllustLayoutView : UserControl
    {
        public IllustLayoutView()
        {
            InitializeComponent();
        }

        //ロード
        private void UserControl_Loaded(object sender, RoutedEventArgs e)
        {
            (this.DataContext as IllustLayoutViewModel).initView();
        }


        //イラストの生成・コレクション登録
        private void checkBoxIllust1_Click(object sender, RoutedEventArgs e)
        {
            (this.DataContext as IllustLayoutViewModel).createAndAddIllust((bool)(sender as CheckBox).IsChecked, 
                                                                           "ILLUST1",
                                                                           "ILLUST1",
                                                                           new IllustState());
        }
        private void checkBoxIllust2_Click(object sender, RoutedEventArgs e)
        {
            (this.DataContext as IllustLayoutViewModel).createAndAddIllust((bool)(sender as CheckBox).IsChecked,
                                                                           "ILLUST2",
                                                                           "ILLUST2",
                                                                           new IllustState());
        }
        private void checkBoxIllust3_Click(object sender, RoutedEventArgs e)
        {
            (this.DataContext as IllustLayoutViewModel).createAndAddIllust((bool)(sender as CheckBox).IsChecked, 
                                                                           "ILLUST3",
                                                                           "ILLUST3",
                                                                           new IllustState());
        }


        //マルチラベル
        private void checkBoxLabelMultiLabel1_Click(object sender, RoutedEventArgs e)
        {
            (this.DataContext as IllustLayoutViewModel).createAndAddLabel((bool)(sender as CheckBox).IsChecked, 
                                                                           "LBL_MULTI1",
                                                                           "LBL_MULTI1",
                                                                           new MultiLabelState());
        }

        private void checkBoxLabelMultiLabel2_Click(object sender, RoutedEventArgs e)
        {
            (this.DataContext as IllustLayoutViewModel).createAndAddLabel((bool)(sender as CheckBox).IsChecked,
                                                                           "LBL_MULTI2",
                                                                           "LBL_MULTI2",
                                                                           new MultiLabelState());
        }

        private void checkBoxLabelMultiLabel3_Click(object sender, RoutedEventArgs e)
        {
            (this.DataContext as IllustLayoutViewModel).createAndAddLabel((bool)(sender as CheckBox).IsChecked, 
                                                                           "LBL_MULTI3",
                                                                           "LBL_MULTI3",
                                                                           new MultiLabelState());
        }

        private void checkBoxLabelMultiLabel4_Click(object sender, RoutedEventArgs e)
        {
            (this.DataContext as IllustLayoutViewModel).createAndAddLabel((bool)(sender as CheckBox).IsChecked, 
                                                                           "LBL_MULTI4",
                                                                           "LBL_MULTI4",
                                                                           new MultiLabelState());
        }

        //文字列方向
        //private void comboBoxTextVector_SelectionChanged(object sender, SelectionChangedEventArgs e)
        //{
        //    (this.DataContext as IllustLayoutViewModel).onTextVectorChanged(sender, e);
        //}
        //文字サイズ
        private void comboBoxFontSize_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            (this.DataContext as IllustLayoutViewModel).onFontSizeComboBoxSelectionChanged(sender, e);
        }
        //フォントファミリ
        private void comboBoxFontFamily_DropDownOpened(object sender, EventArgs e)
        {
            (this.DataContext as IllustLayoutViewModel).onFontFamilyComboBoxOpened(sender, e);
        }
        //フォントファミリ
        private void comboBoxFontFamily_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            (this.DataContext as IllustLayoutViewModel).onFontFamilyComboBoxSelectionChanged(sender, e);
        }
        //文字色
        private void comboBoxFontColor_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            (this.DataContext as IllustLayoutViewModel).onFontColorComboBoxSelectionChanged(sender, e);
        }
        //テキスト
        private void textBoxMultiText_TextChanged(object sender, TextChangedEventArgs e)
        {
            if (DataContext != null)
            (this.DataContext as IllustLayoutViewModel).onMultiTextChanged(sender, e);
        }

        //縮小(-1)
        private void buttonMulti050_Click(object sender, RoutedEventArgs e)
        {
            (this.DataContext as IllustLayoutViewModel).multiplicationIllustSize(0.5);
        }

        //縮小(-10)
        private void buttonMulti090_Click(object sender, RoutedEventArgs e)
        {
            (this.DataContext as IllustLayoutViewModel).multiplicationIllustSize(0.9);
        }

        private void buttonMulti095_Click(object sender, RoutedEventArgs e)
        {
            (this.DataContext as IllustLayoutViewModel).multiplicationIllustSize(0.95);
        }

        private void buttonMulti105_Click(object sender, RoutedEventArgs e)
        {
            (this.DataContext as IllustLayoutViewModel).multiplicationIllustSize(1.05);
        }

        //拡大(+1)
        private void buttonMulti110_Click(object sender, RoutedEventArgs e)
        {
            (this.DataContext as IllustLayoutViewModel).multiplicationIllustSize(1.1);
        }

        //拡大(+10)
        private void buttonMulti150_Click(object sender, RoutedEventArgs e)
        {
            (this.DataContext as IllustLayoutViewModel).multiplicationIllustSize(1.5);
        }

        //コンボボックス　ダウンドロップオープン時（アイテムをリセット）
        private void comboBoxYearSelection_MouseDown(object sender, EventArgs e)
        {
            (this.DataContext as IllustLayoutViewModel).resetYearSelectionComboBox();
        }
        //コンボボックス選択値変更時
        private void comboBoxYearSelection_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            (this.DataContext as IllustLayoutViewModel).onYearSelectionChanged(sender);
        }
        
        //イラストパス変更
        private void buttonIllustPath_Click(object sender, RoutedEventArgs e)
        {
            (this.DataContext as IllustLayoutViewModel).onClickedButtonIllustPath();
        }


    }


    //可変ラベル生成
    class LabelInIllustCanvasFactory
    {

        public static Label createLabel(ILabelState state)
        {
            var label = new Label();
            state.setLabelState(label);
            return label;
        }
    }
}
