﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Hitsuji.Nengajou.ViewModels;
using Hitsuji.Nengajou.Models.InnerCanvasStateModels;

namespace Hitsuji.Nengajou.Views
{
    /// <summary>
    /// ReseiverLayoutView.xaml の相互作用ロジック
    /// </summary>
    public partial class ReseiverLayoutView : UserControl
    {
        public ReseiverLayoutView()
        {
            InitializeComponent();
        }

        private void UserControl_Loaded(object sender, RoutedEventArgs e)
        {
            //ビューに初期値設定
            (DataContext as ReseiverLayoutViewModel).initView();
        }

        #region ▼宛先ラベル

        //宛先〒番号ラベル
        private void checkBoxReseiverPNo_Click(object sender, RoutedEventArgs e)
        {
            var reseiverLayoutVM = (this.DataContext as ReseiverLayoutViewModel);
            reseiverLayoutVM.createAndAddLabel((bool)(sender as CheckBox).IsChecked, "LBL_R_PRIM1", "あ", new ReseiverPNoPreState());
            reseiverLayoutVM.createAndAddLabel((bool)(sender as CheckBox).IsChecked, "LBL_R_PRIM2", "て", new ReseiverPNoPreState());
            reseiverLayoutVM.createAndAddLabel((bool)(sender as CheckBox).IsChecked, "LBL_R_PRIM3", "先", new ReseiverPNoPreState());
            reseiverLayoutVM.createAndAddLabel((bool)(sender as CheckBox).IsChecked, "LBL_R_SECO1", "郵", new ReseiverPNoPostState());
            reseiverLayoutVM.createAndAddLabel((bool)(sender as CheckBox).IsChecked, "LBL_R_SECO2", "便", new ReseiverPNoPostState());
            reseiverLayoutVM.createAndAddLabel((bool)(sender as CheckBox).IsChecked, "LBL_R_SECO3", "番", new ReseiverPNoPostState());
            reseiverLayoutVM.createAndAddLabel((bool)(sender as CheckBox).IsChecked, "LBL_R_SECO4", "号", new ReseiverPNoPostState());

        }
        
        //宛先住所
        private void checkBoxReseiverAddress1_Click(object sender, RoutedEventArgs e)
        {
            var reseiverLayoutVM = (this.DataContext as ReseiverLayoutViewModel);
            reseiverLayoutVM.createAndAddLabel((bool)(sender as CheckBox).IsChecked, "LBL_R_ADDR1",
                                                new StringBuilder("").AppendLine("宛").AppendLine("先").AppendLine("住").AppendLine("所").AppendLine("１")
                                                                     .AppendLine("　").AppendLine("Ａ").AppendLine("Ｂ").AppendLine("Ｃ").AppendLine("Ｄ").AppendLine("Ｅ")
                                                                     .AppendLine("　").AppendLine("三").AppendLine("ノ").AppendLine("五").AppendLine("ノ").AppendLine("七")
                                                                     .ToString(),
                                                new ReseiverAddressState());
        }
        private void checkBoxReseiverAddress2_Click(object sender, RoutedEventArgs e)
        {
            (this.DataContext as ReseiverLayoutViewModel).createAndAddLabel((bool)(sender as CheckBox).IsChecked, "LBL_R_ADDR2",
                                                                             new StringBuilder("")
                                                                                    .AppendLine("宛")
                                                                                    .AppendLine("先")
                                                                                    .AppendLine("住")
                                                                                    .AppendLine("所")
                                                                                    .AppendLine("２")
                                                                                    .ToString(),
                                                                             new ReseiverAddressState());
        }
        private void checkBoxReseiverAddress3_Click(object sender, RoutedEventArgs e)
        {
            (this.DataContext as ReseiverLayoutViewModel).createAndAddLabel((bool)(sender as CheckBox).IsChecked,
                                                                             "LBL_R_ADDR3",
                                                                             new StringBuilder("")
                                                                                    .AppendLine("宛")
                                                                                    .AppendLine("先")
                                                                                    .AppendLine("住")
                                                                                    .AppendLine("所")
                                                                                    .AppendLine("３")
                                                                                    .ToString(),
                                                                             new ReseiverAddressState());
        }

        //宛先氏名
        private void checkBoxReseiverName1_Click(object sender, RoutedEventArgs e)
        {
            (this.DataContext as ReseiverLayoutViewModel).createAndAddLabel((bool)(sender as CheckBox).IsChecked,
                                                                             "LBL_R_NAME1",
                                                                             new StringBuilder("")
                                                                                    .AppendLine("宛")
                                                                                    .AppendLine("先")
                                                                                    .AppendLine("氏")
                                                                                    .AppendLine("名")
                                                                                    .AppendLine("１")
                                                                                    .AppendLine("Ａ")
                                                                                    .AppendLine("Ｂ")
                                                                                    .AppendLine("Ｃ")
                                                                                    .AppendLine("Ｄ")
                                                                                    .AppendLine("Ｅ")
                                                                                    .ToString(),
                                                                             new ReseiverNameState());
        }
        private void checkBoxReseiverName2_Click(object sender, RoutedEventArgs e)
        {
            (this.DataContext as ReseiverLayoutViewModel).createAndAddLabel((bool)(sender as CheckBox).IsChecked,
                                                                             "LBL_R_NAME2",
                                                                             new StringBuilder("")
                                                                                    .AppendLine("宛")
                                                                                    .AppendLine("先")
                                                                                    .AppendLine("氏")
                                                                                    .AppendLine("名")
                                                                                    .AppendLine("２")
                                                                                    .ToString(),
                                                                             new ReseiverNameState());
        }
        private void checkBoxReseiverName3_Click(object sender, RoutedEventArgs e)
        {
            (this.DataContext as ReseiverLayoutViewModel).createAndAddLabel((bool)(sender as CheckBox).IsChecked,
                                                                             "LBL_R_NAME3",
                                                                             new StringBuilder("")
                                                                                    .AppendLine("宛")
                                                                                    .AppendLine("先")
                                                                                    .AppendLine("氏")
                                                                                    .AppendLine("名")
                                                                                    .AppendLine("３")
                                                                                    .ToString(),
                                                                             new ReseiverNameState());
        }
        private void checkBoxReseiverName4_Click(object sender, RoutedEventArgs e)
        {
            (this.DataContext as ReseiverLayoutViewModel).createAndAddLabel((bool)(sender as CheckBox).IsChecked,
                                                                             "LBL_R_NAME4",
                                                                             new StringBuilder("")
                                                                                    .AppendLine("宛")
                                                                                    .AppendLine("先")
                                                                                    .AppendLine("氏")
                                                                                    .AppendLine("名")
                                                                                    .AppendLine("４")
                                                                                    .ToString(),
                                                                             new ReseiverNameState());
        }

        //宛先接尾語
        private void checkBoxReseiverNamePostFix1_Click(object sender, RoutedEventArgs e)
        {
            (this.DataContext as ReseiverLayoutViewModel).createAndAddLabel((bool)(sender as CheckBox).IsChecked,
                                                                             "LBL_R_NPF1",
                                                                             new StringBuilder("")
                                                                                    .AppendLine("接")
                                                                                    .AppendLine("尾")
                                                                                    .AppendLine("語")
                                                                                    .AppendLine("１")
                                                                                    .ToString(),
                                                                             new ReseiverNamePostFixState());
        }
        private void checkBoxReseiverNamePostFix2_Click(object sender, RoutedEventArgs e)
        {
            (this.DataContext as ReseiverLayoutViewModel).createAndAddLabel((bool)(sender as CheckBox).IsChecked,
                                                                             "LBL_R_NPF2",
                                                                             new StringBuilder("")
                                                                                    .AppendLine("接")
                                                                                    .AppendLine("尾")
                                                                                    .AppendLine("語")
                                                                                    .AppendLine("２")
                                                                                    .ToString(),
                                                                             new ReseiverNamePostFixState());
        }
        private void checkBoxReseiverNamePostFix3_Click(object sender, RoutedEventArgs e)
        {
            (this.DataContext as ReseiverLayoutViewModel).createAndAddLabel((bool)(sender as CheckBox).IsChecked,
                                                                             "LBL_R_NPF3",
                                                                             new StringBuilder("")
                                                                                    .AppendLine("接")
                                                                                    .AppendLine("尾")
                                                                                    .AppendLine("語")
                                                                                    .AppendLine("３")
                                                                                    .ToString(),
                                                                             new ReseiverNamePostFixState());
        }
        private void checkBoxReseiverNamePostFix4_Click(object sender, RoutedEventArgs e)
        {
            (this.DataContext as ReseiverLayoutViewModel).createAndAddLabel((bool)(sender as CheckBox).IsChecked,
                                                                             "LBL_R_NPF4",
                                                                             new StringBuilder("")
                                                                                    .AppendLine("接")
                                                                                    .AppendLine("尾")
                                                                                    .AppendLine("語")
                                                                                    .AppendLine("４")
                                                                                    .ToString(),
                                                                             new ReseiverNamePostFixState());
        }
        
        #endregion ▲宛先ラベル

        #region ▼送付者ラベル

        //送付者〒番号ラベル
        private void checkBoxSenderPNo_Click(object sender, RoutedEventArgs e)
        {
            var ReseiverLayoutVM = (this.DataContext as ReseiverLayoutViewModel);
            ReseiverLayoutVM.createAndAddLabel((bool)(sender as CheckBox).IsChecked, "LBL_S_PRIM1", "送", new SenderPNoPreState());
            ReseiverLayoutVM.createAndAddLabel((bool)(sender as CheckBox).IsChecked, "LBL_S_PRIM2", "付", new SenderPNoPreState());
            ReseiverLayoutVM.createAndAddLabel((bool)(sender as CheckBox).IsChecked, "LBL_S_PRIM3", "者", new SenderPNoPreState());
            ReseiverLayoutVM.createAndAddLabel((bool)(sender as CheckBox).IsChecked, "LBL_S_SECO1", "郵", new SenderPNoPostState());
            ReseiverLayoutVM.createAndAddLabel((bool)(sender as CheckBox).IsChecked, "LBL_S_SECO2", "便", new SenderPNoPostState());
            ReseiverLayoutVM.createAndAddLabel((bool)(sender as CheckBox).IsChecked, "LBL_S_SECO3", "番", new SenderPNoPostState());
            ReseiverLayoutVM.createAndAddLabel((bool)(sender as CheckBox).IsChecked, "LBL_S_SECO4", "号", new SenderPNoPostState());
        }

        //送付者住所
        private void checkBoxSenderAddress1_Click(object sender, RoutedEventArgs e)
        {
            (this.DataContext as ReseiverLayoutViewModel).createAndAddLabel((bool)(sender as CheckBox).IsChecked,
                                                                             "LBL_S_ADDR1",
                                                                             new StringBuilder("")
                                                                                    .AppendLine("送")
                                                                                    .AppendLine("付")
                                                                                    .AppendLine("者")
                                                                                    .AppendLine("住")
                                                                                    .AppendLine("所")
                                                                                    .AppendLine("１")
                                                                                    .AppendLine("　")
                                                                                    .AppendLine("Ａ")
                                                                                    .AppendLine("Ｂ")
                                                                                    .AppendLine("Ｃ")
                                                                                    .AppendLine("Ｄ")
                                                                                    .AppendLine("Ｅ")
                                                                                    .AppendLine("六")
                                                                                    .AppendLine("ノ")
                                                                                    .AppendLine("八")
                                                                                    .ToString(),
                                                                             new SenderAddressState());
        }
        private void checkBoxSenderAddress2_Click(object sender, RoutedEventArgs e)
        {
            (this.DataContext as ReseiverLayoutViewModel).createAndAddLabel((bool)(sender as CheckBox).IsChecked,
                                                                             "LBL_S_ADDR2",
                                                                             new StringBuilder("")
                                                                                    .AppendLine("送")
                                                                                    .AppendLine("付")
                                                                                    .AppendLine("者")
                                                                                    .AppendLine("住")
                                                                                    .AppendLine("所")
                                                                                    .AppendLine("２")
                                                                                    .ToString(),
                                                                             new SenderAddressState());
        }
        private void checkBoxSenderAddress3_Click(object sender, RoutedEventArgs e)
        {
            (this.DataContext as ReseiverLayoutViewModel).createAndAddLabel((bool)(sender as CheckBox).IsChecked,
                                                                             "LBL_S_ADDR3",
                                                                             new StringBuilder("")
                                                                                    .AppendLine("送")
                                                                                    .AppendLine("付")
                                                                                    .AppendLine("者")
                                                                                    .AppendLine("住")
                                                                                    .AppendLine("所")
                                                                                    .AppendLine("３")
                                                                                    .ToString(),
                                                                             new SenderAddressState());
        }

        //送付者氏名
        private void checkBoxSenderName1_Click(object sender, RoutedEventArgs e)
        {
            (this.DataContext as ReseiverLayoutViewModel).createAndAddLabel((bool)(sender as CheckBox).IsChecked,
                                                                             "LBL_S_NAME1",
                                                                             new StringBuilder("")
                                                                                    .AppendLine("送")
                                                                                    .AppendLine("付")
                                                                                    .AppendLine("者")
                                                                                    .AppendLine("氏")
                                                                                    .AppendLine("名")
                                                                                    .AppendLine("１")
                                                                                    .AppendLine("Ａ")
                                                                                    .AppendLine("Ｂ")
                                                                                    .AppendLine("Ｃ")
                                                                                    .AppendLine("Ｄ")
                                                                                    .AppendLine("Ｅ")
                                                                                    .ToString(),
                                                                             new SenderNameState());
        }
        private void checkBoxSenderName2_Click(object sender, RoutedEventArgs e)
        {
            (this.DataContext as ReseiverLayoutViewModel).createAndAddLabel((bool)(sender as CheckBox).IsChecked,
                                                                             "LBL_S_NAME2",
                                                                             new StringBuilder("")
                                                                                    .AppendLine("送")
                                                                                    .AppendLine("付")
                                                                                    .AppendLine("者")
                                                                                    .AppendLine("氏")
                                                                                    .AppendLine("名")
                                                                                    .AppendLine("２")
                                                                                    .ToString(),
                                                                             new SenderNameState());
        }
        private void checkBoxSenderName3_Click(object sender, RoutedEventArgs e)
        {
            (this.DataContext as ReseiverLayoutViewModel).createAndAddLabel((bool)(sender as CheckBox).IsChecked,
                                                                             "LBL_S_NAME3",
                                                                             new StringBuilder("")
                                                                                    .AppendLine("送")
                                                                                    .AppendLine("付")
                                                                                    .AppendLine("者")
                                                                                    .AppendLine("氏")
                                                                                    .AppendLine("名")
                                                                                    .AppendLine("３")
                                                                                    .ToString(),
                                                                             new SenderNameState());
        }
        private void checkBoxSenderName4_Click(object sender, RoutedEventArgs e)
        {
            (this.DataContext as ReseiverLayoutViewModel).createAndAddLabel((bool)(sender as CheckBox).IsChecked,
                                                                             "LBL_S_NAME4",
                                                                             new StringBuilder("")
                                                                                    .AppendLine("送")
                                                                                    .AppendLine("付")
                                                                                    .AppendLine("者")
                                                                                    .AppendLine("氏")
                                                                                    .AppendLine("名")
                                                                                    .AppendLine("４")
                                                                                    .ToString(),
                                                                             new SenderNameState());
        }
        //送付者TEL
        private void checkBoxTel_Click(object sender, RoutedEventArgs e)
        {
            (this.DataContext as ReseiverLayoutViewModel).createAndAddLabel((bool)(sender as CheckBox).IsChecked,
                                                                             "LBL_S_TEL",
                                                                             new StringBuilder("")
                                                                                    .AppendLine("送")
                                                                                    .AppendLine("付")
                                                                                    .AppendLine("者")
                                                                                    .AppendLine("Ｔ")
                                                                                    .AppendLine("Ｅ")
                                                                                    .AppendLine("Ｌ")
                                                                                    .AppendLine("　")
                                                                                    .AppendLine("一")
                                                                                    .AppendLine("二")
                                                                                    .AppendLine("三")
                                                                                    .AppendLine("四")
                                                                                    .AppendLine("五")
                                                                                    .AppendLine("〇")
                                                                                    .ToString(),
                                                                             new SenderTelState());
        }

        #endregion ▲送付者ラベル

        private void comboBoxFontSize_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            (this.DataContext as ReseiverLayoutViewModel).onFontSizeComboBoxSelectionChanged(sender, e);
        }

        private void comboBoxFontFamily_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            (this.DataContext as ReseiverLayoutViewModel).onFontFamilyComboBoxSelectionChanged(sender, e);
        }

        private void comboBoxFontColor_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            (this.DataContext as ReseiverLayoutViewModel).onFontColorComboBoxSelectionChanged(sender, e);
        }

        private void comboBoxFontFamily_DropDownOpened(object sender, EventArgs e)
        {
            (this.DataContext as ReseiverLayoutViewModel).onFontFamilyComboBoxOpened(sender, e);
        }
    }
}
